﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using System.Windows.Forms;

namespace WiMoKeyMapping
{
    internal class KeyboardEmulation
    {
        private KeyboardEmulation() { }

        internal static void VkDone()
        {
            NativeMethods.keybd_event(
                (byte)Keys.RWin,
                0,
                NativeMethods.KEYEVENTF_SILENT,
                0);
            NativeMethods.keybd_event(
                (byte)Keys.F6,
                0,
                NativeMethods.KEYEVENTF_SILENT,
                0);
            NativeMethods.keybd_event(
                (byte)Keys.F6,
                0,
                NativeMethods.KEYEVENTF_SILENT | NativeMethods.KEYEVENTF_KEYUP,
                0);
            NativeMethods.keybd_event(
                (byte)Keys.RWin,
                0,
                NativeMethods.KEYEVENTF_SILENT | NativeMethods.KEYEVENTF_KEYUP,
                0);
        }

        private static void EmulateKeyPress(Keys theKey)
        {
            NativeMethods.keybd_event(
                (byte)theKey,
                0,
                NativeMethods.KEYEVENTF_SILENT,
                0);
            NativeMethods.keybd_event(
                (byte)theKey,
                0,
                NativeMethods.KEYEVENTF_SILENT | NativeMethods.KEYEVENTF_KEYUP,
                0);
        }

        internal static void VkTHome()
        {
            EmulateKeyPress(Keys.LWin);
        }

        internal static void VkTSoft1()
        {
            EmulateKeyPress(Keys.F1);
        }

        internal static void VkTSoft2()
        {
            EmulateKeyPress(Keys.F2);
        }

        internal static void VkTTalk()
        {
            EmulateKeyPress(Keys.F3);
        }

        internal static void VkTEnd()
        {
            EmulateKeyPress(Keys.F4);
        }

        internal static void VkTVolumeUp()
        {
            EmulateKeyPress(Keys.F6);
        }

        internal static void VkTVolumeDown()
        {
            EmulateKeyPress(Keys.F7);
        }

        internal static void VkEndAllDataCalls()
        {
            EmulateKeyPress(Keys.F15);
        }

        internal static void VkTSpeakerphoneToggle()
        {
            EmulateKeyPress(Keys.F16);
        }

        internal static void VkKeyLock()
        {
            EmulateKeyPress(Keys.F22);
        }

        private class NativeMethods
        {
            private NativeMethods() { }

            [DllImport("coredll.dll")]
            public static extern void keybd_event(
                byte bVk,
                byte bScan,
                uint dwFlags,
                uint dwExtraInfo);

            public const uint KEYEVENTF_KEYUP = 0x0002;
            public const uint KEYEVENTF_SILENT = 0x0004;
        }
    }
}
